Imports System.Runtime.InteropServices
Imports System.ComponentModel
Imports System.Windows.Forms
 
'Add-in Express RTD Server Module
<GuidAttribute("07DB6F70-9493-4BFD-AC43-361D90017329"), ProgIdAttribute("RTDandAddin_vb.RTDServerModule"), RunInstaller(true)> _
Public Class RTDServerModule
    Inherits AddinExpress.RTD.ADXRTDServerModule
    Friend WithEvents adxrtdTopic2 As AddinExpress.RTD.ADXRTDTopic
    Friend WithEvents adxrtdTopic3 As AddinExpress.RTD.ADXRTDTopic
    Friend WithEvents adxrtdTopic1 As AddinExpress.RTD.ADXRTDTopic

#Region " Component Designer generated code. "
    'Required by designer
    Private components As System.ComponentModel.IContainer
 
    'Required by designer - do not modify
    'the following method
    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.adxrtdTopic2 = New AddinExpress.RTD.ADXRTDTopic(Me.components)
        Me.adxrtdTopic3 = New AddinExpress.RTD.ADXRTDTopic(Me.components)
        Me.adxrtdTopic1 = New AddinExpress.RTD.ADXRTDTopic(Me.components)
        '
        'adxrtdTopic2
        '
        Me.adxrtdTopic2.String01 = "MyTopic1"
        Me.adxrtdTopic2.Tag = ""
        Me.adxrtdTopic2.UseStoredValue = True
        '
        'adxrtdTopic3
        '
        Me.adxrtdTopic3.String01 = "MyTopic2"
        Me.adxrtdTopic3.Tag = ""
        Me.adxrtdTopic3.UseStoredValue = True
        '
        'adxrtdTopic1
        '
        Me.adxrtdTopic1.String01 = "MyTopic"
        Me.adxrtdTopic1.Tag = ""
        Me.adxrtdTopic1.UseStoredValue = True
        '
        'RTDServerModule
        '
        Me.Interval = 1000

    End Sub
 
#End Region
 
#Region " ADX automatic code "
 
    'Required by Add-in Express - do not modify
    'the methods within this region
 
    Public Overrides Function GetContainer() As System.ComponentModel.IContainer
        If components Is Nothing Then
            components = New System.ComponentModel.Container
        End If
        GetContainer = components
    End Function
 
    <ComRegisterFunctionAttribute()> _
    Public Shared Sub RTDServerRegister(ByVal t As Type)
        AddinExpress.RTD.ADXRTDServerModule.ADXRTDServerRegister(t)
    End Sub
 
    <ComUnregisterFunctionAttribute()> _
    Public Shared Sub RTDServerUnregister(ByVal t As Type)
        AddinExpress.RTD.ADXRTDServerModule.ADXRTDServerUnregister(t)
    End Sub
 
#End Region
 
    'RTD Server Module Implementation
 
    Public Sub New()
        MyBase.New()
 
        'This call is required by the Component Designer
        InitializeComponent()
 
        'Add any initialization after the InitializeComponent() call
 
    End Sub
 
    Private excelApp As Excel._Application = Nothing

    Private Function GetModule() As AddinModule
        Dim index As Object
        Dim addin As Office.COMAddIn
        Dim addins As Office.COMAddIns
        Dim i As Integer

        Try
            excelApp = Marshal.GetActiveObject("Excel.Application")
            addins = excelApp.COMAddIns
            For i = 1 To addins.Count
                index = i
                addin = addins.Item(index)
                If Not (CType(addin.Object, AddinModule) Is Nothing) Then
                    Return addin.Object
                End If
            Next
        Catch
        End Try
        Return Nothing
    End Function

    Private isTopicsActive As Boolean = False
    Friend WithEvents addinModule As addinModule

    Private Sub InitializeRTDServerModule()
        addinModule = GetModule()
    End Sub

    Private Sub FinalizeRTDServerModule()
        addinModule = Nothing
    End Sub

    Private Sub addinModule_EnableRTDFunctions() Handles addinModule.EnableRTDFunctions
        isTopicsActive = True
    End Sub

    Private Sub addinModule_DisableRTDFunctions() Handles addinModule.DisableRTDFunctions
        isTopicsActive = False
    End Sub

    Private value1 As Object = String.Empty

    Private Function adxrtdTopic1_RefreshData(ByVal sender As Object) As Object Handles adxrtdTopic1.RefreshData
        If excelApp Is Nothing Then
            InitializeRTDServerModule()
        End If
        If (isTopicsActive) Then
            Dim Rnd As System.Random = New System.Random
            value1 = Rnd.Next(2000)
            Return (value1)
        Else
            Return value1
        End If
    End Function

    Private value2 As Object = String.Empty

    Private Function adxrtdTopic2_RefreshData(ByVal sender As Object) As Object Handles adxrtdTopic2.RefreshData
        If excelApp Is Nothing Then
            InitializeRTDServerModule()
        End If
        If (isTopicsActive) Then
            Dim Rnd As System.Random = New System.Random
            value2 = (Rnd.Next(2000) / 2)
            Return (value2)
        Else
            Return value2
        End If
    End Function

    Private value3 As Object = String.Empty

    Private Function adxrtdTopic3_RefreshData(ByVal sender As Object) As Object Handles adxrtdTopic3.RefreshData
        If excelApp Is Nothing Then
            InitializeRTDServerModule()
        End If
        If (isTopicsActive) Then
            Dim Rnd As System.Random = New System.Random
            value3 = (Rnd.Next(2000) / 3)
            Return (value3)
        Else
            Return value3
        End If
    End Function

    Private Sub RTDServerModule_RTDFinalize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.RTDFinalize
        Try
            FinalizeRTDServerModule()
        Catch
        End Try
    End Sub
End Class

